/***************************************************************************
 *   Copyright (C) 2004 by stefano                                         *
 *   stefano@xiaprojects.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef XGTASKBAR_H
#define XGTASKBAR_H

#include <qwidget.h>
#include "xeconfiguration.h"

#include <qpixmap.h>
#include <qbitmap.h>

/**
@author stefano
*/
class XGTaskBar : public QWidget
{
Q_OBJECT
public:
    XGTaskBar(QWidget *parent = 0, const char *name = 0);

    ~XGTaskBar();
    void paintEvent( QPaintEvent *e);
    void xUpdate();
protected:
	XSConfigurations * ActiveConfiguration;
	uint	TaskBarHeight;
	uint	TaskBarWidth;
	uint ObjectTaskWidth;
	uint ObjectTaskHeight;
	
	uint	TaskBarX;
	uint	TaskBarY;
	QPixmap		paintBuffer;
	QBitmap 	maskBuffer;
	QBitmap 	objectBuffer;
	QPixmap		imgFakeBackgroundGlobal;
	
	uint	ObectCounter;
	class XGDocker *xGDocker;
	class KRootPixmap	*KDesktopBackground;

public slots:
    void xStop();
    void xStart();
    void xApplyCfg();
    void xEventRemoveIcon(int);
    void xEventTaskOpen(int);
    void backgroundUpdated(const QPixmap &);
    void xSetup();
};

#endif
